package se.softstuff.nb.nbtranslate.ide.importw;

import se.softstuff.nb.nbtranslate.ide.create.CreateProjectVisualPanel3;
import java.io.File;
import java.io.IOException;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.filechooser.FileFilter;
import org.openide.filesystems.FileObject;
import org.openide.filesystems.FileUtil;
import org.openide.loaders.DataObject;
import org.openide.loaders.DataObjectNotFoundException;
import org.openide.util.NbBundle;
import org.openide.util.NbPreferences;
import se.softstuff.nb.nbtranslate.data.NbTranslationDataObject;
import se.softstuff.nb.nbtranslate.swing.NbBundleDiffFileFilter;

public final class ImportVisualPanel1 extends JPanel {

    public static final String LAST_LOCATION = "lastLocation";

    private String projectFilePath;

    /**
     * Creates new form ImportVisualPanel1
     */
    public ImportVisualPanel1() {
        initComponents();
        String path = NbPreferences.forModule(CreateProjectVisualPanel3.class).get(LAST_LOCATION, new File(".").getAbsolutePath());
        locationTextField.setText(path);
    }

    @Override
    public String getName() {
        return NbBundle.getMessage(getClass(), "ImportVisualPanel1.bulletin");
    }

    public NbTranslationDataObject getProjectFile() {
        try {
            FileObject fobject = FileUtil.toFileObject(new File(locationTextField.getText()));
            DataObject data = DataObject.find(fobject);
            NbTranslationDataObject projectFile = (NbTranslationDataObject) data;
            return projectFile;
        } catch (DataObjectNotFoundException ex) {
            throw new RuntimeException("Failed to read NbBundleDiffDataObject from " + projectFilePath, ex);
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        locationLabel = new javax.swing.JLabel();
        locationTextField = new javax.swing.JTextField();
        browseButton = new javax.swing.JButton();

        setName("Form"); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(locationLabel, NbBundle.getMessage(ImportVisualPanel1.class, "ImportVisualPanel1.locationLabel.text")); // NOI18N
        locationLabel.setName("locationLabel"); // NOI18N

        locationTextField.setName("locationTextField"); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(browseButton, NbBundle.getMessage(ImportVisualPanel1.class, "ImportVisualPanel1.browseButton.text")); // NOI18N
        browseButton.setName("browseButton"); // NOI18N
        browseButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                browseButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(locationTextField)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(browseButton, javax.swing.GroupLayout.PREFERRED_SIZE, 84, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(locationLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 128, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 252, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(6, 6, 6)
                .addComponent(locationLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(locationTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(browseButton))
                .addContainerGap(251, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void browseButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_browseButtonActionPerformed

        String location = locationTextField.getText();
        JFileChooser destinationChooser = new JFileChooser(location);
        destinationChooser.setFileFilter(new NbBundleDiffFileFilter());
        destinationChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
        destinationChooser.setMultiSelectionEnabled(false);
        destinationChooser.setDialogTitle(NbBundle.getMessage(this.getClass(), "ImportVisualPanel1.selectTranslateFile.title"));
        int answer = destinationChooser.showOpenDialog(this);
        if (answer != JFileChooser.APPROVE_OPTION) {
            return;
        }

        File projectLocation = destinationChooser.getSelectedFile();

        projectFilePath = projectLocation.getAbsolutePath();
        locationTextField.setText(projectFilePath);
        NbPreferences.forModule(CreateProjectVisualPanel3.class).put(LAST_LOCATION, projectFilePath);

        
    }//GEN-LAST:event_browseButtonActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton browseButton;
    private javax.swing.JLabel locationLabel;
    private javax.swing.JTextField locationTextField;
    // End of variables declaration//GEN-END:variables

    
}
